Index: trunk/source/processes/electromagnetic/adjoint/src/G4AdjointCSManager.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4AdjointCSManager.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4AdjointCSManager.cc	(revision 1196)
@@ -794,5 +907,7 @@
 {
  if (theAdjPartDef->GetParticleName() == "adj_e-") return G4Electron::Electron();
- if (theAdjPartDef->GetParticleName() == "adj_gamma") return G4Gamma::Gamma();
+ else if (theAdjPartDef->GetParticleName() == "adj_gamma") return G4Gamma::Gamma();
+ else if (theAdjPartDef->GetParticleName() == "adj_proton") return G4Proton::Proton();
+ else if (theAdjPartDef == theAdjIon) return theFwdIon;
  return 0; 	
 }
@@ -805,23 +920,41 @@
     currentMaterial = const_cast<G4Material*> (couple->GetMaterial());
     currentMatIndex = couple->GetIndex();
-    //G4cout<<"Index material "<<currentMatIndex<<std::endl;
+    lastPartDefForCS =0;
+    LastEkinForCS =0;
+    LastCSCorrectionFactor =1.;
   }  
 }
 
-
-
-///////////////////////////////////////////////////////
-//
-double G4AdjointCSManager::ComputeAdjointCS(G4double aPrimEnergy,G4AdjointCSMatrix*
+///////////////////////////////////////////////////////
+//
+void G4AdjointCSManager::DefineCurrentParticle(const G4ParticleDefinition* aPartDef)
+{
+  if(aPartDef != currentParticleDef) {
+  
+  	currentParticleDef= const_cast< G4ParticleDefinition* > (aPartDef);
+	massRatio=1;
+	if (aPartDef == theAdjIon) massRatio = proton_mass_c2/aPartDef->GetPDGMass();
+  	currentParticleIndex=1000000;
+ 	for (size_t i=0;i<theListOfAdjointParticlesInAction.size();i++){
+  		if (aPartDef == theListOfAdjointParticlesInAction[i]) currentParticleIndex=i;
+  	}	
+	 
+  }  
+}
+
+
+
+/////////////////////////////////////////////////////////////////////////////////////////////////
+//
+G4double G4AdjointCSManager::ComputeAdjointCS(G4double aPrimEnergy,G4AdjointCSMatrix*
 				anAdjointCSMatrix,G4double Tcut)
 { 
-  std::vector< G4double > *theLogPrimEnergyVector = anAdjointCSMatrix->GetLogPrimEnergyVector();
+  std::vector< double> *theLogPrimEnergyVector = anAdjointCSMatrix->GetLogPrimEnergyVector();
   if (theLogPrimEnergyVector->size() ==0){
- 	G4cout<<"No data are contained in the given AdjointCSMatrix!"<<std::endl;
-	G4cout<<"The sampling procedure will be stopped."<<std::endl;
+ 	G4cout<<"No data are contained in the given AdjointCSMatrix!"<<G4endl;
+	G4cout<<"The s"<<G4endl;
 	return 0.;
 	
   }
-  //G4cout<<"A prim/Tcut "<<aPrimEnergy<<'\t'<<Tcut<<std::endl; 
   G4double log_Tcut = std::log(Tcut);
   G4double log_E =std::log(aPrimEnergy);
@@ -834,15 +967,11 @@
  
   size_t ind =theInterpolator->FindPositionForLogVector(log_E,*theLogPrimEnergyVector);
-  //G4cout<<"Prim energy "<<(*thePrimEnergyVector)[0]<<std::endl;
-  //G4cout<<"Prim energy[ind]"<<(*thePrimEnergyVector)[ind]<<std::endl;
-  //G4cout<<"Prim energy ind"<<ind<<std::endl;
-  
   G4double aLogPrimEnergy1,aLogPrimEnergy2;
   G4double aLogCS1,aLogCS2;
   G4double log01,log02;
-  std::vector< G4double>* aLogSecondEnergyVector1 =0;
-  std::vector< G4double>* aLogSecondEnergyVector2  =0;
-  std::vector< G4double>* aLogProbVector1=0;
-  std::vector< G4double>* aLogProbVector2=0;
+  std::vector< double>* aLogSecondEnergyVector1 =0;
+  std::vector< double>* aLogSecondEnergyVector2  =0;
+  std::vector< double>* aLogProbVector1=0;
+  std::vector< double>* aLogProbVector2=0;
   std::vector< size_t>* aLogProbVectorIndex1=0;
   std::vector< size_t>* aLogProbVectorIndex2=0;
@@ -851,16 +980,8 @@
   anAdjointCSMatrix->GetData(ind, aLogPrimEnergy1,aLogCS1,log01, aLogSecondEnergyVector1,aLogProbVector1,aLogProbVectorIndex1);
   anAdjointCSMatrix->GetData(ind+1, aLogPrimEnergy2,aLogCS2,log02, aLogSecondEnergyVector2,aLogProbVector2,aLogProbVectorIndex2);
-  //G4cout<<"aSecondEnergyVector1.size() "<<aSecondEnergyVector1->size()<<std::endl;
-  //G4cout<<aSecondEnergyVector1<<std::endl;
-  //G4cout<<"aSecondEnergyVector2.size() "<<aSecondEnergyVector2->size()<<std::endl;
   if (anAdjointCSMatrix->IsScatProjToProjCase()){ //case where the Tcut plays a role
 	G4double log_minimum_prob1, log_minimum_prob2;
-	
-	//G4cout<<aSecondEnergyVector1->size()<<std::endl;
 	log_minimum_prob1=theInterpolator->InterpolateForLogVector(log_Tcut,*aLogSecondEnergyVector1,*aLogProbVector1);
 	log_minimum_prob2=theInterpolator->InterpolateForLogVector(log_Tcut,*aLogSecondEnergyVector2,*aLogProbVector2);
-	//G4cout<<"minimum_prob1 "<< std::exp(log_minimum_prob1)<<std::endl;
-	//G4cout<<"minimum_prob2 "<< std::exp(log_minimum_prob2)<<std::endl;
-	//G4cout<<"Tcut "<<std::endl;
 	aLogCS1+= log_minimum_prob1;
 	aLogCS2+= log_minimum_prob2;
Index: trunk/source/processes/electromagnetic/adjoint/src/G4AdjointCSMatrix.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4AdjointCSMatrix.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4AdjointCSMatrix.cc	(revision 1196)
@@ -24,10 +24,12 @@
 // ********************************************************************
 //
+// $Id: G4AdjointCSMatrix.cc,v 1.4 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
+
 #include "G4AdjointCSMatrix.hh"
 #include <iomanip>
 #include <fstream>
-
 #include "G4AdjointInterpolator.hh"
-
 ///////////////////////////////////////////////////////
 //
@@ -64,20 +66,18 @@
 ///////////////////////////////////////////////////////
 //
- void G4AdjointCSMatrix::AddData(G4double aLogPrimEnergy,G4double aLogCS, std::vector< G4double>* aLogSecondEnergyVector,
-	 							       std::vector< G4double>* aLogProbVector,size_t n_pro_decade){
+ void G4AdjointCSMatrix::AddData(G4double aLogPrimEnergy,G4double aLogCS, std::vector< double>* aLogSecondEnergyVector,
+	 							       std::vector< double>* aLogProbVector,size_t n_pro_decade){
 	
 	G4AdjointInterpolator* theInterpolator=G4AdjointInterpolator::GetInstance();
-	//Add this time we consider that the energy are given monotically
 	
+	//At this time we consider that the energy is increasing monotically
 	theLogPrimEnergyVector.push_back(aLogPrimEnergy);
 	theLogCrossSectionVector.push_back(aLogCS);
 	theLogSecondEnergyMatrix.push_back(aLogSecondEnergyVector);
-	//G4cout<<"Test Add Data "<<this<<'\t'<<aSecondEnergyVector->size()<<std::endl;
-	//G4cout<<theSecondEnergyMatrix.size()<<std::endl;
 	theLogProbMatrix.push_back(aLogProbVector);
-	//G4cout<<"Test Add Data 1 "<<this<<'\t'<<aSecondEnergyVector->size()<<std::endl;
-	//G4cout<<theSecondEnergyMatrix.size()<<std::endl;
+	
 	std::vector< size_t>* aLogProbVectorIndex = 0;
 	dlog =0;
+	
 	if (n_pro_decade > 0 && aLogProbVector->size()>0) {
 		aLogProbVectorIndex = new std::vector< size_t>();
@@ -85,4 +85,5 @@
 		G4double log_val = int(std::min((*aLogProbVector)[0],aLogProbVector->back())/dlog)*dlog;
 		log0Vector.push_back(log_val);
+		
 		while(log_val<0.) {
 			aLogProbVectorIndex->push_back(theInterpolator->FindPosition(log_val,(*aLogProbVector)));
@@ -102,20 +103,14 @@
 ///////////////////////////////////////////////////////
 //
-bool G4AdjointCSMatrix::GetData(unsigned int i, G4double& aLogPrimEnergy,G4double& aLogCS,G4double& log0, std::vector< G4double>*& aLogSecondEnergyVector,
-	 							       std::vector< G4double>*& aLogProbVector, std::vector< size_t>*& aLogProbVectorIndex)
+G4bool G4AdjointCSMatrix::GetData(unsigned int i, G4double& aLogPrimEnergy,G4double& aLogCS,G4double& log0, std::vector< double>*& aLogSecondEnergyVector,
+	 							       std::vector< double>*& aLogProbVector, std::vector< size_t>*& aLogProbVectorIndex)
 {	if (i>= nb_of_PrimEnergy) return false;
-	//G4cout<<"Test Get Data "<<std::endl;
+	//G4cout<<"Test Get Data "<<G4endl;
 	aLogPrimEnergy = theLogPrimEnergyVector[i];
 	aLogCS = theLogCrossSectionVector[i];
 	aLogSecondEnergyVector = theLogSecondEnergyMatrix[i];
-	//G4cout<<"Test Get Data "<<this<<'\t'<<theSecondEnergyMatrix[i]->size()<<std::endl;
-	//G4cout<<"Test Get Data "<<this<<'\t'<<aSecondEnergyVector->size()<<std::endl;
-	//G4cout<<"Test Get Data "<<this<<'\t'<<aSecondEnergyVector<<std::endl;
 	aLogProbVector = theLogProbMatrix[i];
 	aLogProbVectorIndex = theLogProbMatrixIndex[i];
 	log0=log0Vector[i];
-	//G4cout<<"Test Get Data 1 "<<this<<'\t'<<theProbMatrix[i]->size()<<std::endl;
-	//G4cout<<"Test Get Data 1 "<<this<<'\t'<<aProbVector->size()<<std::endl;
-	//G4cout<<"Test Get Data 1 "<<this<<'\t'<<aLogProbVectorIndex<<std::endl;
 	return true;
 	
@@ -127,9 +122,9 @@
  	FileOutput<<std::setiosflags(std::ios::scientific);
  	FileOutput<<std::setprecision(6);
-	FileOutput<<theLogPrimEnergyVector.size()<<std::endl;
+	FileOutput<<theLogPrimEnergyVector.size()<<G4endl;
 	for (size_t i=0;i<theLogPrimEnergyVector.size();i++){
-		FileOutput<<std::exp(theLogPrimEnergyVector[i])/MeV<<'\t'<<std::exp(theLogCrossSectionVector[i])<<std::endl;
+		FileOutput<<std::exp(theLogPrimEnergyVector[i])/MeV<<'\t'<<std::exp(theLogCrossSectionVector[i])<<G4endl;
 		size_t j1=0;
-		FileOutput<<theLogSecondEnergyMatrix[i]->size()<<std::endl;
+		FileOutput<<theLogSecondEnergyMatrix[i]->size()<<G4endl;
 		for (size_t j=0;j<theLogSecondEnergyMatrix[i]->size();j++){
 			FileOutput<<std::exp((*theLogSecondEnergyMatrix[i])[j]);
@@ -137,11 +132,11 @@
 			if (j1<10) FileOutput<<'\t';
 			else  {
-				FileOutput<<std::endl;
+				FileOutput<<G4endl;
 				j1=0;
 			}	
 		}
-		if (j1>0) FileOutput<<std::endl;
+		if (j1>0) FileOutput<<G4endl;
 		j1=0;
-		FileOutput<<theLogProbMatrix[i]->size()<<std::endl;
+		FileOutput<<theLogProbMatrix[i]->size()<<G4endl;
 		for (size_t j=0;j<theLogProbMatrix[i]->size();j++){
 			FileOutput<<std::exp((*theLogProbMatrix[i])[j]);
@@ -149,9 +144,9 @@
 			if (j1<10) FileOutput<<'\t';
 			else  {
-				FileOutput<<std::endl;
+				FileOutput<<G4endl;
 				j1=0;
 			}	
 		}
-		if (j1>0) FileOutput<<std::endl;
+		if (j1>0) FileOutput<<G4endl;
 		
 		
@@ -177,6 +172,6 @@
 		theLogCrossSectionVector.push_back(CS);
 		FileOutput>>n2;
-		theLogSecondEnergyMatrix.push_back(new std::vector<double>());
-		theLogProbMatrix.push_back(new std::vector<double>());
+		theLogSecondEnergyMatrix.push_back(new std::vector<G4double>());
+		theLogProbMatrix.push_back(new std::vector<G4double>());
 		
 		for (size_t j=0; j<n2;j++){
Index: trunk/source/processes/electromagnetic/adjoint/src/G4AdjointComptonModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4AdjointComptonModel.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4AdjointComptonModel.cc	(revision 1196)
@@ -24,4 +24,7 @@
 // ********************************************************************
 //
+// $Id: G4AdjointComptonModel.cc,v 1.5 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
 #include "G4AdjointComptonModel.hh"
 #include "G4AdjointCSManager.hh"
@@ -34,4 +37,5 @@
 #include "G4AdjointGamma.hh"
 #include "G4Gamma.hh"
+#include "G4KleinNishinaCompton.hh"
 
 
@@ -44,5 +48,4 @@
   SetUseMatrix(true);
   SetUseMatrixPerElement(true);
-  SetIsIonisation(false);
   SetUseOnlyOneMatrixForAllElements(true);
   theAdjEquivOfDirectPrimPartDef =G4AdjointGamma::AdjointGamma();
@@ -50,4 +53,5 @@
   theDirectPrimaryPartDef=G4Gamma::Gamma();
   second_part_of_same_type=false;
+  theDirectEMModel=new G4KleinNishinaCompton(G4Gamma::Gamma(),"ComptonDirectModel");
  
 }
@@ -62,5 +66,5 @@
 	               G4ParticleChange* fParticleChange)
 { 
-   
+   if (!UseMatrix) return RapidSampleSecondaries(aTrack,IsScatProjToProjCase,fParticleChange); 
    
    //A recall of the compton scattering law is 
@@ -71,25 +75,14 @@
    
   const G4DynamicParticle* theAdjointPrimary =aTrack.GetDynamicParticle();
-  //DefineCurrentMaterial(aTrack->GetMaterialCutsCouple());
-  size_t ind= 0;
-  
-  
- 
- 
- //Elastic inverse scattering //not correct in all the cases 
- //---------------------------------------------------------
- G4double adjointPrimKinEnergy = theAdjointPrimary->GetKineticEnergy();
- 
- //G4cout<<adjointPrimKinEnergy<<std::endl;
- if (adjointPrimKinEnergy>HighEnergyLimit*0.999){
+  G4double adjointPrimKinEnergy = theAdjointPrimary->GetKineticEnergy();
+  if (adjointPrimKinEnergy>HighEnergyLimit*0.999){
  	return;
- }
+  }
+ 
  
  //Sample secondary energy
  //-----------------------
  G4double gammaE1;
-
- gammaE1 = SampleAdjSecEnergyFromCSMatrix(ind,
- 						  adjointPrimKinEnergy,
+ gammaE1 = SampleAdjSecEnergyFromCSMatrix(adjointPrimKinEnergy,
 						  IsScatProjToProjCase);
  
@@ -108,5 +101,5 @@
  //Cos th
  //-------
-// G4cout<<"Compton scattering "<<gammaE1<<'\t'<<gammaE2<<std::endl;
+// G4cout<<"Compton scattering "<<gammaE1<<'\t'<<gammaE2<<G4endl;
  G4double cos_th = 1.+ electron_mass_c2*(1./gammaE1 -1./gammaE2);
  if (!IsScatProjToProjCase) {
@@ -116,5 +109,5 @@
  G4double sin_th = 0.;
  if (std::abs(cos_th)>1){
- 	//G4cout<<"Problem in compton scattering with cos_th "<<cos_th<<std::endl;
+ 	//G4cout<<"Problem in compton scattering with cos_th "<<cos_th<<G4endl;
 	if (cos_th>0) {
 		cos_th=1.;
@@ -136,15 +129,19 @@
  G4ThreeVector gammaMomentum1 = gammaE1*G4ThreeVector(std::cos(phi)*sin_th,std::sin(phi)*sin_th,cos_th);
  gammaMomentum1.rotateUz(dir_parallel);
-// G4cout<<gamma0Energy<<'\t'<<gamma0Momentum<<std::endl;
+// G4cout<<gamma0Energy<<'\t'<<gamma0Momentum<<G4endl;
  
  
  //It is important to correct the weight of particles before adding the secondary
  //------------------------------------------------------------------------------
- CorrectPostStepWeight(fParticleChange, aTrack.GetWeight(), adjointPrimKinEnergy,gammaE1);
- 
- if (!IsScatProjToProjCase && CorrectWeightMode){ //kill the primary and add a secondary
+ CorrectPostStepWeight(fParticleChange, 
+ 			aTrack.GetWeight(), 
+			adjointPrimKinEnergy,
+			gammaE1,
+			IsScatProjToProjCase);
+ 
+ if (!IsScatProjToProjCase){ //kill the primary and add a secondary
  	fParticleChange->ProposeTrackStatus(fStopAndKill);
  	fParticleChange->AddSecondary(new G4DynamicParticle(theAdjEquivOfDirectPrimPartDef,gammaMomentum1));
-	//G4cout<<"gamma0Momentum "<<gamma0Momentum<<std::endl;
+	//G4cout<<"gamma0Momentum "<<gamma0Momentum<<G4endl;
  }
  else {
@@ -154,5 +151,125 @@
  
  	
-} 			
+} 
+////////////////////////////////////////////////////////////////////////////////
+//
+void G4AdjointComptonModel::RapidSampleSecondaries(const G4Track& aTrack,
+                       G4bool IsScatProjToProjCase,
+	               G4ParticleChange* fParticleChange)
+{ 
+
+ const G4DynamicParticle* theAdjointPrimary =aTrack.GetDynamicParticle();
+ DefineCurrentMaterial(aTrack.GetMaterialCutsCouple());
+ 
+ 
+ G4double adjointPrimKinEnergy = theAdjointPrimary->GetKineticEnergy();
+
+ 
+ if (adjointPrimKinEnergy>HighEnergyLimit*0.999){
+ 	return;
+ }
+  
+ 
+ G4double diffCSUsed=currentMaterial->GetElectronDensity()*twopi_mc2_rcl2; 
+ G4double gammaE1=0.;
+ G4double gammaE2=0.;
+ if (!IsScatProjToProjCase){
+ 	
+	G4double Emax = GetSecondAdjEnergyMaxForProdToProjCase(adjointPrimKinEnergy);
+        G4double Emin=  GetSecondAdjEnergyMinForProdToProjCase(adjointPrimKinEnergy);;
+	if (Emin>=Emax) return;
+	G4double f1=(Emin-adjointPrimKinEnergy)/Emin;
+	G4double f2=(Emax-adjointPrimKinEnergy)/Emax/f1;
+	gammaE1=adjointPrimKinEnergy/(1.-f1*pow(f2,G4UniformRand()));;
+	gammaE2=gammaE1-adjointPrimKinEnergy;
+	diffCSUsed= diffCSUsed*(1.+2.*log(1.+electron_mass_c2/adjointPrimKinEnergy))*adjointPrimKinEnergy/gammaE1/gammaE2;
+	
+ 	
+ }
+ else {	G4double Emax = GetSecondAdjEnergyMaxForScatProjToProjCase(adjointPrimKinEnergy);
+	G4double Emin = GetSecondAdjEnergyMinForScatProjToProjCase(adjointPrimKinEnergy,currentTcutForDirectSecond);
+	if (Emin>=Emax) return;
+	gammaE2 =adjointPrimKinEnergy;
+	gammaE1=Emin*pow(Emax/Emin,G4UniformRand());
+	diffCSUsed= diffCSUsed/gammaE1;
+	
+ }
+  
+  
+  
+						  	
+ //Weight correction
+ //-----------------------
+ //First w_corr is set to the ratio between adjoint total CS and fwd total CS
+ G4double w_corr=G4AdjointCSManager::GetAdjointCSManager()->GetPostStepWeightCorrection();
+
+ //Then another correction is needed due to the fact that a biaised differential CS has been used rather than the 
+ //one consistent with the direct model
+ 
+ 
+ G4double diffCS = DiffCrossSectionPerAtomPrimToScatPrim(gammaE1, gammaE2,1,0.);
+ if (diffCS >0)  diffCS /=G4direct_CS;  // here we have the normalised diffCS
+ diffCS*=theDirectEMProcess->GetLambda(gammaE1,currentCouple);
+ //diffCS*=theDirectEMModel->CrossSectionPerVolume(currentMaterial,G4Gamma::Gamma(),gammaE1,0.,2.*gammaE1);
+ //G4cout<<"diffCS/diffCSUsed "<<diffCS/diffCSUsed<<'\t'<<gammaE1<<'\t'<<gammaE2<<G4endl;                                 
+ 
+ w_corr*=diffCS/diffCSUsed;
+	   
+ G4double new_weight = aTrack.GetWeight()*w_corr;
+ fParticleChange->SetParentWeightByProcess(false);
+ fParticleChange->SetSecondaryWeightByProcess(false);
+ fParticleChange->ProposeParentWeight(new_weight); 
+ 
+ 
+ 
+ //Cos th
+ //-------
+
+ G4double cos_th = 1.+ electron_mass_c2*(1./gammaE1 -1./gammaE2);
+ if (!IsScatProjToProjCase) {
+ 	G4double p_elec=theAdjointPrimary->GetTotalMomentum();
+	cos_th = (gammaE1 - gammaE2*cos_th)/p_elec;
+ }
+ G4double sin_th = 0.;
+ if (std::abs(cos_th)>1){
+ 	//G4cout<<"Problem in compton scattering with cos_th "<<cos_th<<G4endl;
+	if (cos_th>0) {
+		cos_th=1.;
+	}
+	else 	cos_th=-1.;
+	sin_th=0.;
+ }
+ else  sin_th = std::sqrt(1.-cos_th*cos_th);
+
+ 
+ 
+ 
+ //gamma0 momentum
+ //--------------------
+
+ 
+ G4ThreeVector dir_parallel=theAdjointPrimary->GetMomentumDirection();
+ G4double phi =G4UniformRand()*2.*3.1415926;
+ G4ThreeVector gammaMomentum1 = gammaE1*G4ThreeVector(std::cos(phi)*sin_th,std::sin(phi)*sin_th,cos_th);
+ gammaMomentum1.rotateUz(dir_parallel);
+ 
+ 
+
+ 
+ if (!IsScatProjToProjCase){ //kill the primary and add a secondary
+ 	fParticleChange->ProposeTrackStatus(fStopAndKill);
+ 	fParticleChange->AddSecondary(new G4DynamicParticle(theAdjEquivOfDirectPrimPartDef,gammaMomentum1));
+	//G4cout<<"gamma0Momentum "<<gamma0Momentum<<G4endl;
+ }
+ else {
+ 	fParticleChange->ProposeEnergy(gammaE1);
+	fParticleChange->ProposeMomentumDirection(gammaMomentum1.unit());
+ }
+ 
+ 
+ 
+} 
+
+			
 ////////////////////////////////////////////////////////////////////////////////
 //
@@ -179,7 +296,9 @@
                                       G4double )
 { //Based on Klein Nishina formula
- //* In the forward case (see G4KleinNishinaModel)  the  cross section is parametrised while the secondaries are sampled from the 
+ // In the forward case (see G4KleinNishinaModel)  the  cross section is parametrised while
+ // the secondaries are sampled from the 
  // Klein Nishida differential cross section
- // The used diffrential cross section here is therefore the cross section multiplied by the normalidsed differential Klein Nishida cross section
+ // The used diffrential cross section here is therefore the cross section multiplied by the normalised 
+ //differential Klein Nishida cross section
  
  
@@ -191,8 +310,8 @@
  G4double gamEnergy1_min = gamEnergy0/one_plus_two_epsi;
  if (gamEnergy1 >gamEnergy1_max ||  gamEnergy1<gamEnergy1_min) {
- 	/*G4cout<<"the differential CS is null"<<std::endl;
-	G4cout<<gamEnergy0<<std::endl;
-	G4cout<<gamEnergy1<<std::endl;
-	G4cout<<gamEnergy1_min<<std::endl;*/
+ 	/*G4cout<<"the differential CS is null"<<G4endl;
+	G4cout<<gamEnergy0<<G4endl;
+	G4cout<<gamEnergy1<<G4endl;
+	G4cout<<gamEnergy1_min<<G4endl;*/
  	return 0.;
  }
@@ -222,12 +341,12 @@
  //-------------------------------
  
- G4double G4direct_CS = theDirectEMModel->ComputeCrossSectionPerAtom(G4Gamma::Gamma(),
+ G4direct_CS = theDirectEMModel->ComputeCrossSectionPerAtom(G4Gamma::Gamma(),
                                              gamEnergy0,
                                              Z, 0., 0.,0.);
  
  dCS_dE1 *= G4direct_CS/CS;
-/* G4cout<<"the differential CS is not null"<<std::endl;
- G4cout<<gamEnergy0<<std::endl;
- G4cout<<gamEnergy1<<std::endl;*/
+/* G4cout<<"the differential CS is not null"<<G4endl;
+ G4cout<<gamEnergy0<<G4endl;
+ G4cout<<gamEnergy1<<G4endl;*/
  
  return dCS_dE1;
@@ -235,4 +354,5 @@
 
 }
+				      
 ////////////////////////////////////////////////////////////////////////////////
 //
@@ -251,2 +371,38 @@
   return  emin; 
 }
+////////////////////////////////////////////////////////////////////////////////
+//
+G4double G4AdjointComptonModel::AdjointCrossSection(const G4MaterialCutsCouple* aCouple,
+				             G4double primEnergy,
+				             G4bool IsScatProjToProjCase)
+{ 
+  if (UseMatrix) return G4VEmAdjointModel::AdjointCrossSection(aCouple,primEnergy,IsScatProjToProjCase);
+  DefineCurrentMaterial(aCouple);
+  
+  
+  G4double Cross=0.;
+  G4double Emax_proj =0.;
+  G4double Emin_proj =0.;
+  if (!IsScatProjToProjCase ){
+  	Emax_proj = GetSecondAdjEnergyMaxForProdToProjCase(primEnergy);
+  	Emin_proj = GetSecondAdjEnergyMinForProdToProjCase(primEnergy);
+	if (Emax_proj>Emin_proj ){
+		 Cross= log((Emax_proj-primEnergy)*Emin_proj/Emax_proj/(Emin_proj-primEnergy))
+		 						*(1.+2.*log(1.+electron_mass_c2/primEnergy));
+	}	 
+  }
+  else {
+        Emax_proj = GetSecondAdjEnergyMaxForScatProjToProjCase(primEnergy);
+	Emin_proj = GetSecondAdjEnergyMinForScatProjToProjCase(primEnergy,0.);
+	if (Emax_proj>Emin_proj) {
+		Cross = log(Emax_proj/Emin_proj);
+		//+0.5*primEnergy*primEnergy(1./(Emin_proj*Emin_proj) - 1./(Emax_proj*Emax_proj)); neglected at the moment
+	}
+  	
+  	
+  }
+  
+  Cross*=currentMaterial->GetElectronDensity()*twopi_mc2_rcl2;
+  lastCS=Cross;
+  return Cross;	
+}
Index: trunk/source/processes/electromagnetic/adjoint/src/G4AdjointInterpolator.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4AdjointInterpolator.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4AdjointInterpolator.cc	(revision 1196)
@@ -24,4 +24,7 @@
 // ********************************************************************
 //
+// $Id: G4AdjointInterpolator.cc,v 1.4 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
 #include "G4AdjointCSMatrix.hh"
 #include "G4AdjointInterpolator.hh"
@@ -61,5 +64,5 @@
 G4double G4AdjointInterpolator::LinearInterpolation(G4double& x,G4double& x1,G4double& x2,G4double& y1,G4double& y2)
 { G4double res = y1+ (x-x1)*(y2-y1)/(x2-x1);
-  //G4cout<<"Linear "<<res<<std::endl;
+  //G4cout<<"Linear "<<res<<G4endl;
   return res;	
 }
@@ -69,8 +72,8 @@
 { if (y1<=0 || y2<=0 || x1<=0) return LinearInterpolation(x,x1,x2,y1,y2);
   G4double B=std::log(y2/y1)/std::log(x2/x1);
-  //G4cout<<"x1,x2,y1,y2 "<<x1<<'\t'<<x2<<'\t'<<y1<<'\t'<<y2<<'\t'<<std::endl;
+  //G4cout<<"x1,x2,y1,y2 "<<x1<<'\t'<<x2<<'\t'<<y1<<'\t'<<y2<<'\t'<<G4endl;
   G4double A=y1/std::pow(x1,B);
   G4double res=A*std::pow(x,B);
- // G4cout<<"Log "<<res<<std::endl;
+ // G4cout<<"Log "<<res<<G4endl;
   return res;
 }
@@ -98,5 +101,5 @@
   }
   else {
-  	//G4cout<<"The interpolation method that you invoked does not exist!"<<std::endl; 
+  	//G4cout<<"The interpolation method that you invoked does not exist!"<<G4endl; 
 	return -1111111111.;
   }
@@ -104,7 +107,7 @@
 ///////////////////////////////////////////////////////
 //
-size_t  G4AdjointInterpolator::FindPosition(G4double& x,std::vector<double>& x_vec,size_t , size_t ) //only valid if x_vec is monotically increasing
+size_t  G4AdjointInterpolator::FindPosition(G4double& x,std::vector<G4double>& x_vec,size_t , size_t ) //only valid if x_vec is monotically increasing
 {  //most rapid nethod could be used probably
-   //It is important to put std::vector<double>& such that the vector itself is used and not a copy
+   //It is important to put std::vector<G4double>& such that the vector itself is used and not a copy
   
   
@@ -149,8 +152,8 @@
 ///////////////////////////////////////////////////////
 //
-size_t  G4AdjointInterpolator::FindPositionForLogVector(G4double& log_x,std::vector<double>& log_x_vec) //only valid if x_vec is monotically increasing
+size_t  G4AdjointInterpolator::FindPositionForLogVector(G4double& log_x,std::vector<G4double>& log_x_vec) //only valid if x_vec is monotically increasing
 {  //most rapid nethod could be used probably
-   //It is important to put std::vector<double>& such that the vector itself is used and not a copy
-  
+   //It is important to put std::vector<G4double>& such that the vector itself is used and not a copy
+  return FindPosition(log_x, log_x_vec);
   if (log_x_vec.size()>3){ 
   	size_t ind=0;
@@ -170,9 +173,9 @@
 ///////////////////////////////////////////////////////
 //
-G4double G4AdjointInterpolator::Interpolate(G4double& x,std::vector<double>& x_vec,std::vector<double>& y_vec,G4String InterPolMethod)
+G4double G4AdjointInterpolator::Interpolate(G4double& x,std::vector<G4double>& x_vec,std::vector<G4double>& y_vec,G4String InterPolMethod)
 { size_t i=FindPosition(x,x_vec);
-  //G4cout<<i<<std::endl;
-  //G4cout<<x<<std::endl;
-  //G4cout<<x_vec[i]<<std::endl; 
+  //G4cout<<i<<G4endl;
+  //G4cout<<x<<G4endl;
+  //G4cout<<x_vec[i]<<G4endl; 
   return Interpolation(	x,x_vec[i],x_vec[i+1],y_vec[i],y_vec[i+1],InterPolMethod);
 }
@@ -180,5 +183,5 @@
 ///////////////////////////////////////////////////////
 //
-G4double G4AdjointInterpolator::InterpolateWithIndexVector(G4double& x,std::vector<double>& x_vec,std::vector<double>& y_vec,
+G4double G4AdjointInterpolator::InterpolateWithIndexVector(G4double& x,std::vector<G4double>& x_vec,std::vector<G4double>& y_vec,
 					    std::vector<size_t>& index_vec,G4double x0, G4double dx) //only linear interpolation possible
 { size_t ind=0;
@@ -202,14 +205,14 @@
 ///////////////////////////////////////////////////////
 //
-G4double G4AdjointInterpolator::InterpolateForLogVector(G4double& log_x,std::vector<double>& log_x_vec,std::vector<double>& log_y_vec)
+G4double G4AdjointInterpolator::InterpolateForLogVector(G4double& log_x,std::vector<G4double>& log_x_vec,std::vector<G4double>& log_y_vec)
 { //size_t i=0;
   size_t i=FindPositionForLogVector(log_x,log_x_vec);
-  /*G4cout<<"In interpolate "<<std::endl;
-  G4cout<<i<<std::endl;
-  G4cout<<log_x<<std::endl;
-  G4cout<<log_x_vec[i]<<std::endl;
-  G4cout<<log_x_vec[i+1]<<std::endl;
-  G4cout<<log_y_vec[i]<<std::endl;
-  G4cout<<log_y_vec[i+1]<<std::endl;*/
+  /*G4cout<<"In interpolate "<<G4endl;
+  G4cout<<i<<G4endl;
+  G4cout<<log_x<<G4endl;
+  G4cout<<log_x_vec[i]<<G4endl;
+  G4cout<<log_x_vec[i+1]<<G4endl;
+  G4cout<<log_y_vec[i]<<G4endl;
+  G4cout<<log_y_vec[i+1]<<G4endl;*/
   
   G4double log_y=LinearInterpolation(log_x,log_x_vec[i],log_x_vec[i+1],log_y_vec[i],log_y_vec[i+1]);
